/**
 * Copyright 2008-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.impl.enhanced.api.basic;


/**
 * @author Gael Lalire
 */
public class CreatePoolItemException extends Exception {

    private static final long serialVersionUID = 6925951282630413069L;

    private Long brokenTime;

    public CreatePoolItemException(final Long brokenTime) {
        this.brokenTime = brokenTime;
    }

    public CreatePoolItemException(final Long brokenTime, final String message) {
        super(message);
        this.brokenTime = brokenTime;
    }

    public CreatePoolItemException(final Long brokenTime, final Throwable cause) {
        super(cause);
        this.brokenTime = brokenTime;
    }

    public CreatePoolItemException(final Long brokenTime, final String message, final Throwable cause) {
        super(message, cause);
        this.brokenTime = brokenTime;
    }

    /**
     * @return the broken time, if null then the factory will be forever broken
     */
    public Long getBrokenTime() {
        return brokenTime;
    }

}
