/**
 * Copyright 2008-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.impl.enhanced.api.basic;

import org.ow2.util.pool.impl.enhanced.api.PoolException;

/**
 * @author Gael Lalire
 */
public class PoolFactoryBroken extends PoolException {

    private static final long serialVersionUID = 183617037543364579L;

    private Long expireBrokenDeadline;

    public PoolFactoryBroken(final Long expireBrokenDeadline) {
        super();
        this.expireBrokenDeadline = expireBrokenDeadline;
    }

    public PoolFactoryBroken(final Long expireBrokenDeadline, final String message, final Throwable cause) {
        super(message, cause);
        this.expireBrokenDeadline = expireBrokenDeadline;
    }

    public PoolFactoryBroken(final Long expireBrokenDeadline, final String message) {
        super(message);
        this.expireBrokenDeadline = expireBrokenDeadline;
    }

    public Long getExpireBrokenDeadline() {
        return expireBrokenDeadline;
    }

}
