/**
 * Copyright 2008-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.impl.enhanced.api.basic.clue;

import org.ow2.util.pool.impl.enhanced.api.IWaitControl;
import org.ow2.util.pool.impl.enhanced.api.IllegalTimeoutException;
import org.ow2.util.pool.impl.enhanced.api.TimeoutPoolException;
import org.ow2.util.pool.impl.enhanced.api.WaiterInterruptedException;
import org.ow2.util.pool.impl.enhanced.api.basic.IBasicPool;
import org.ow2.util.pool.impl.enhanced.api.basic.PoolFactoryBroken;
import org.ow2.util.pool.impl.enhanced.api.resizer.clue.IResizableCluePool;

/**
 * @author Gael Lalire
 * @param <E> pool item type
 * @param <C> clue type
 */
public interface IBasicCluePool<E, C> extends IBasicPool<E>, IResizableCluePool<E, C> {

    E get(C clue) throws WaiterInterruptedException, PoolFactoryBroken, InterruptedException;

    E get(C clue, IWaitControl timeout) throws TimeoutPoolException, IllegalTimeoutException, WaiterInterruptedException,
            PoolFactoryBroken, InterruptedException;

}
