/**
 * Copyright 2008-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.impl.enhanced.api.listener;

import org.ow2.util.pool.impl.enhanced.api.IWaitControl;


/**
 *
 * @author Gael Lalire
 * @param <E> pool item type
 */
public interface IPoolListener<E> {

    void getMethodCalled(IWaitControl timeout);

    void getMethodReturned(E result, IWaitControl timeout);

    void getMethodFailed(Exception e, IWaitControl timeout);

    void putMethodCalled(E poolItem);

    void putMethodReturned(E poolItem);

    void putMethodFailed(Exception e, E poolItem);

    void removeMethodCalled(E poolItem);

    void removeMethodReturned(E poolItem);

    void removeMethodFailed(Exception e, E poolItem);

    void signalAllWaitersMethodCalled();

    void signalAllWaitersMethodReturned();

    void signalAllWaitersMethodFailed(Exception e);

}
