/**
 * Copyright 2008-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.impl.enhanced.api.validator.clue;

import org.ow2.util.pool.impl.enhanced.api.validator.IPoolValidator;

/**
 *
 * @author Gael Lalire
 * @param <E> pool item type
 * @param <C> clue type
 */
public interface ICluePoolValidator<E, C> extends IPoolValidator<E> {

    /**
     * This method is called when you try to get a pool item
     * with a clue.
     * If you try to get an item without a clue then the method
     * in {@link IPoolValidator} will be called.
     * @param poolItem
     * @param clue
     * @return
     */
    boolean validate(E poolItem, C clue);

}
