/**
 * Copyright 2008-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.impl.enhanced.deprecated;

import org.ow2.util.pool.api.PoolException;
import org.ow2.util.pool.impl.enhanced.api.IWaitControl;
import org.ow2.util.pool.impl.enhanced.api.basic.IPoolItemFactory;
import org.ow2.util.pool.impl.enhanced.api.basic.IPoolItemRemoveListener;
import org.ow2.util.pool.impl.enhanced.api.validator.clue.ICluePoolValidator;
import org.ow2.util.pool.impl.enhanced.impl.listener.clue.CluePoolListenerAdapter;

/**
 *
 * @author Gael Lalire
 * @param <E>
 * @param <C>
 * @deprecated
 */
@Deprecated
public class PoolFactoryImpl<E, C> extends CluePoolListenerAdapter<E, C> implements IPoolItemFactory<E>,
        ICluePoolValidator<E, C>, IPoolItemRemoveListener<E> {

    private PoolFactory<E, C> factory;

    public PoolFactoryImpl(final PoolFactory<E, C> factory) {
        this.factory = factory;
    }

    public E createPoolItem() {
        try {
            return factory.create(null);
        } catch (PoolException e) {
            e.printStackTrace();
        }
        return null;
    }

    public void setClue(final E item, final C clue) {
        factory.setClue(item, clue);
    }

    @Override
    public void getMethodReturned(final E result, final IWaitControl timeout) {
        factory.activate(result, null);
    }

    @Override
    public void getMethodReturned(final E result, final C clue, final IWaitControl timeout) {
        factory.activate(result, clue);
    }

    /**
     * Called after a pool item is available in pool.
     */
    @Override
    public void putMethodReturned(final E poolItem) {
        factory.passivate(poolItem);
    }

    public boolean validate(final E poolItem, final C clue) {
        return factory.validate(poolItem);
    }

    public boolean validate(final E poolItem) {
        return factory.validate(poolItem);
    }

    public void poolItemRemoved(final E poolItem) {
        factory.remove(poolItem);
    }

}
