/**
 * Copyright 2008-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.impl.enhanced.impl.basic;

/**
 *
 * @author Gael Lalire
 * @param <E>
 */
public class RemoveEntry<E> {

    private RemoveEntry<E> next;

    private E poolItem;

    private boolean callBackComplete;

    public RemoveEntry(final E poolItem, final RemoveEntry<E> next) {
        this.poolItem = poolItem;
        this.next = next;
        callBackComplete = false;
    }

    public RemoveEntry<E> getNext() {
        return next;
    }

    public void setNext(final RemoveEntry<E> next) {
        this.next = next;
    }

    public E getPoolItem() {
        return poolItem;
    }

    public boolean isCallBackComplete() {
        return callBackComplete;
    }

    public void setCallBackComplete(final boolean callBackComplete) {
        this.callBackComplete = callBackComplete;
    }

}
