/**
 * Copyright 2008-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.impl.enhanced.impl.keepbusy;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Gael Lalire
 */
public class PoolItemInfo {

    private int busyCount;

    private boolean removed;

    private List<Throwable> throwableList;

    public PoolItemInfo() {
        this.busyCount = 1;
        this.removed = false;
        throwableList = new ArrayList<Throwable>();
    }

    /**
     * @return the busyCount
     */
    public int getBusyCount() {
        return busyCount;
    }

    /**
     * @param busyCount the busyCount to set
     */
    public void setBusyCount(final int busyCount) {
        this.busyCount = busyCount;
    }

    /**
     * @return the removed
     */
    public boolean isRemoved() {
        return removed;
    }

    /**
     * @param removed the removed to set
     */
    public void setRemoved(final boolean removed) {
        this.removed = removed;
    }

    public void addStackTraceElements(final Throwable throwable) {
        throwableList.add(throwable);
    }

    public List<Throwable> getThrowableList() {
        return throwableList;
    }

}
