/**
 * Copyright 2008-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.impl.enhanced.impl.listener.resizer;

/**
 *
 * @author Gael Lalire
 */
public enum UpdateMethod {

    NEVER, BEFORE, AFTER_SUCCESSFUL, BEFORE_AFTER_SUCCESSFUL,
    AFTER_FAILED, BEFORE_AFTER_FAILED, AFTER, ALWAYS;

    public boolean isBefore() {
        boolean before = false;
        switch (this) {
        case BEFORE:
        case BEFORE_AFTER_FAILED:
        case BEFORE_AFTER_SUCCESSFUL:
        case ALWAYS:
            before = true;
        default:
            break;
        }
        return before;
    }

    public boolean isAfterSuccessful() {
        boolean afterSuccessful = false;
        switch (this) {
        case AFTER:
        case AFTER_SUCCESSFUL:
        case BEFORE_AFTER_SUCCESSFUL:
        case ALWAYS:
            afterSuccessful = true;
        default:
            break;
        }
        return afterSuccessful;
    }

    public boolean isAfterFailed() {
        boolean afterFailed = false;
        switch (this) {
        case AFTER:
        case AFTER_FAILED:
        case BEFORE_AFTER_FAILED:
        case ALWAYS:
            afterFailed = true;
        default:
            break;
        }
        return afterFailed;
    }


}
