/**
 * Copyright 2008-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.impl.enhanced.impl.listener.statistics;

import org.ow2.util.pool.impl.enhanced.internal.resizer.api.statistics.StockerStatistics;

/**
 *
 * @author Gael Lalire
 */
public class BasicPoolStats implements StockerStatistics {

    private int waiters;

    private int notSendedBack;

    /**
     * @return the waiters
     */
    public int getWaiters() {
        return waiters;
    }

    /**
     * @param waiters the waiters to set
     */
    public void setWaiters(final int waiters) {
        this.waiters = waiters;
    }

    /**
     * @return the notSendedBack
     */
    public int getNotSendedBack() {
        return notSendedBack;
    }

    /**
     * @param notSendedBack the notSendedBack to set
     */
    public void setNotSendedBack(final int notSendedBack) {
        this.notSendedBack = notSendedBack;
    }

    /**
     * We assume that a pool item is stocked when it is not in pool.
     */
    public int getStockedCount() {
        return notSendedBack;
    }


}
