/**
 * Copyright 2008-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.impl.enhanced.impl.thread.threadpoolexecutor;

import java.util.concurrent.Executor;

import org.ow2.util.pool.impl.enhanced.api.IPool;
import org.ow2.util.pool.impl.enhanced.api.thread.IReusableThread;
import org.ow2.util.pool.impl.enhanced.impl.thread.AbstractReusableThread;

/**
 *
 * @author Gael Lalire
 */
public class ExecutorReusableThread extends AbstractReusableThread {

    private Executor executor;

    public ExecutorReusableThread(final Executor executor) {
        this.executor = executor;
    }

    @Override
    public void setUsed(final IPool<IReusableThread> reusableThreadPool, final Runnable runnable) {
        super.setUsed(reusableThreadPool, runnable);
        executor.execute(this);
    }

}
