/**
 * Copyright 2008-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.impl.enhanced.impl.thread.threadpoolexecutor;

import java.util.concurrent.Executor;

import org.ow2.util.pool.impl.enhanced.api.basic.IPoolItemFactory;
import org.ow2.util.pool.impl.enhanced.api.thread.IReusableThread;

/**
 *
 * @author Gael Lalire
 */
public class ExecutorReusableThreadFactory implements IPoolItemFactory<IReusableThread> {

    private Executor executor;

    public ExecutorReusableThreadFactory(final Executor executor) {
        this.executor = executor;
    }

    public ExecutorReusableThread createPoolItem() {
        return new ExecutorReusableThread(executor);
    }

}
