/**
 * Copyright 2008-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.impl.enhanced.impl.waitcontrol;

import java.util.concurrent.locks.Condition;

import org.ow2.util.pool.impl.enhanced.api.IWaitControl;
import org.ow2.util.pool.impl.enhanced.api.WaiterInterruptedException;
import org.ow2.util.pool.impl.enhanced.internal.conditionWaitPart.IConditionWaitPart;

/**
 * @author Gael Lalire
 */
public class NoWaitControl implements IWaitControl {

    public static final NoWaitControl INSTANCE = new NoWaitControl();

    protected NoWaitControl() {
    }

    public void popWaitAuthorization() {
    }

    public void pushWaitAuthorization(final WaitAuthorization waitAuthorization) {
    }

    public boolean waitOnCondition(final Condition condition) throws InterruptedException, WaiterInterruptedException {
        return false;
    }

    public boolean waitOnMutex(final Object mutex) throws InterruptedException, WaiterInterruptedException {
        return false;
    }

    public boolean canContinueToWait() {
        return false;
    }

    public boolean waitOnConditionWaitPart(final IConditionWaitPart condition) throws InterruptedException,
            WaiterInterruptedException {
        return false;
    }

    public void verifyInterrupted() throws WaiterInterruptedException {
    }

}
