/**
 * Copyright 2008-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.impl.enhanced.internal.actionscheduler;

import java.util.concurrent.Callable;

/**
 * An action cannot throw an exception.
 * @author Gael Lalire
 */
public interface IAction extends Callable<Boolean> {

    /**
     * This method must respect following contract.
     * Contract :
     * - If Thread.interrupt() is called, the flag must not be cleared by action code. If you were
     * waiting (not a expected behavior) then recall Thread.interrupt() and return normally.
     * - return true if the action was performed false otherwise
     */
    Boolean call();

}
