/**
 * Copyright 2008-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.impl.enhanced.internal.actionscheduler;


/**
 * An action scheduler always schedules the same action.
 * So we can cancel any of them.
 *
 * An action can be performed too late so the functional code abort it.
 * Functional code have to return false if action was aborted.
 *
 * If scheduleAction perform the action in his thread, the cancelAction will
 * returns almost always 0 (it could returns 1 but this imply concurrent call).
 *
 * @author Gael Lalire
 */
public interface IActionScheduler {

    void scheduleAction(final int time);

    int cancelAction(final int time);

}
