/**
 * Copyright 2008-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.impl.enhanced.internal.thread.impl;

import java.lang.ref.WeakReference;

/**
 *
 * @author Gael Lalire
 * @param <T>
 */
public abstract class CleanableWeakReference<T> extends WeakReference<T> implements ICleanable {

    public CleanableWeakReference(final T referent, final Cleaner cleaner) {
        super(referent, cleaner.getReferenceQueue());
        cleaner.add();
    }

}
